;;; -*- mode: emacs-lisp; coding: euc-jp; -*-
;$Id: rpm-mode.el,v 1.38 2000/02/07 15:13:10 mk Exp $
;;;                           RPM-MODE 
;;; rpm-mode.el -- mode for editing spec file.
;;
;; Author: Kanda Mitsuru <kanda@nn.iij4u.or.jp> 1997-2000
;; Created: Nov 1997
;; Modified: MATSUMOTO Shoji <shom@i.h.kyoto-u.ac.jp> 1998
;;           MATSUDA Shigeki <matsu@math.s.chiba-u.ac.jp> 1999
;; 
;;
;; This program is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program; if not, you can either send email to this
;; program's maintainer or write to: The Free Software Foundation,
;; Inc.; 59 Temple Place, Suite 330; Boston, MA 02111-1307, USA.
;;
;; <<Ϥ>>
;; spec ե(ä˺ǽ餫)񤯤Ȥʤ褦ˡ
;; rpm-mode.eläƤߤޤrpm ޥɤƤӽФ褦
;; ƤߤޤΤǻƤߤƤ
;; ۤɼפȤϻפʤΤǡ
;; äˡ̵ޥʡС󥢥åפ򷫤֤ƤޤΤǡ
;; ȤˤʤƤϡޤˡȤˬƥåƤ
;; (http://www.nn.iij4u.or.jp/~kanda/)
;; Х֤δְ㤤δְ㤤Ϥޤ󤢤Ȼפޤ
;; ȯ줿ϡϢemail: kanda@nn.iij4u.or.jp
;;
;; <<Setting>>
;; ~/.emacs  ʲ򵭽ҤƤ
;; ;;RPM-MODE
;; (setq auto-mode-alist (nconc '(("\\.spec" . rpm-mode)) auto-mode-alist))
;; (autoload 'rpm-mode "rpm-mode" "Major mode for editing SPEC file of RPM." t)
;; ʲϤߤ˹碌ƵҤƤ
;; (setq packager "Kanda Mitsuru <kanda@nn.iij4u.or.jp>");ʬ̾
;; (setq buildrootroot "/tmp") ; <buildroot>/<packagename> ˤʤޤ
;;                             ; (ǥեȤ /var/tmp)
;; (setq projectoname "jrpm") ; ץ̾ (jrpm,pjeƤޤ)
;; 
;; Mule-2.3@19.34Emacs20XEmacsǤ font-lock-mode ͭƤС 
;; ɤ顼ޤ
;; (=> (global-font-lock-mode t) ʤɤ ~/.emacs˽񤤤Ƥ)
;; Emacs19.28 ١ Mule Ǥ hilit19 ˤƥ顼ޤ
;;
;; <<Usage>>
;; [1] Ϥ
;;  rpm-mode-map  define-key ˥Хɤޤ
;; ñȥХɤ ̾
;;     1) %  %ϤޤΤϡŪ C-c (Ƭʸ) 㳰ͭ
;;     2) ¾ C-c (Ƭξʸ)
;; ȤƤޤ(ܤϲ rpm-mode-map ΥȤ򻲾ȤΤ)
;; 褯ȤǤΤ
;; C-c h إ
;; C-c d %changelog Ѥ date
;; C-c r rpm ޥɤμ¹
;; C-c v rpmĶѿ
;; C-c l ǥ쥯ȥΥ
;; ޤ
;; ޤXǻѤξϥ˥塼СѰդƤޤ
;; ̡rpm ѥåȤϻʤäƤȻפޤ
;; 쵤ޤʬȤʤɤϡ
;; C-c I ¹ԤƤ(Ū˺äƤ)
;; λޤ褯ʬʤʬñ˥꥿󥭡򲡤ФƤ
;; ("â" BuildRoot: ϻȤΤʤʤ٤ϤƤ)
;; C-c S  %setupޥƤӽФȤϡ
;; C-c s  Source ƤʤФʤޤ
;; (C-c I ǥ󥿥饯ƥ֥⡼ɻƤϤʤ)
;; Ʊͤˡ
;; C-c P  %patchޥƤӽФȤϡ
;; C-c p  Patch ƤʤФʤޤ
;; (C-c I ǥ󥿥饯ƥ֥⡼ɻƤϤʤ)
;;
;; [2] rpm ޥɤθƤӽФ
;; rpm ޥɤƤӽФȤϡC-c r 
;;
;; [3] إ
;; spec եλȤ륿ץȡĶѿ  C-c h ǳǧǤޤ
;;
;; [4] ǥ쥯ȥ/ե ꥹȤΥ  (C-c l)
;; BuildRoot (C-c bʤɤǸƤӽФ)ƤС
;; (º rpm⡼ɤƤΤѿ buildroot ʤΤǡ
;;  ʬǥڥåե BuildRootϤƤȤϡ
;;  ȽǤǤʤΤǡ䤷Ƥޤ)
;; C-c l BuildRootʲΥǥ쥯ȥΥפȤޤ
;; (Ƥʤ硢褦˼䤷Ƥޤ)
;; (%files ʲή""ˤǤ礦)
;; C-c l ¹Ԥ BuildRoot(Ĥޤrpm-mode.elѿbuildroot)
;; ƤʤȤϡơϤޤ
;;
;; <<TODO>>
;; * rpm-interactive-install-info () θ
;;   (Ĥޤꡢ %preun  /sbin/install-info --delete ...)     
(provide 'rpm-mode)

; emacs 19.28 Ǥϡhilit Ȥ
(cond
 ((and 
   (not (featurep 'xemacs))
   (string= (substring emacs-version 0 5) "19.28")
   (eq window-system 'x))
  (require 'hilit19))
 )

(defvar rpm-mode-map nil
  "RPM ⡼ɥХåեΤΥ륭ޥå")

(defvar project "jrpm")
(cond 
 ((string-match project "jrpm")
  (defvar distribution "Japanese RPM(JRPM)")
  (defvar vendor "Linux Japanese RPM Project"))
 ((string-match project "pje")
  (defvar distribution "PJE")
  (defvar vendor "Project Japanese Extentions"))
 (t
  (defvar distribution "") ;  "RPM ⡼ɤǤ Distribution: "
  (defvar vendor ""))      ;  "RPM ⡼ɤǤ Vendor: "
)


(defvar buildrootroot "/var/tmp"
  "Ƥ RPM ⡼ɤ Build: <buildrootroot>/<name> ˤʤ")

(if rpm-mode-map
    ()
  (setq rpm-mode-map (make-sparse-keymap))
  (define-key rpm-mode-map "\C-ca" 'rpm-add-all)                  
					;ŬʿХåե
  (define-key rpm-mode-map "\C-cv" 'rpm-interactive-variable)     
					;Ķѿ
  (define-key rpm-mode-map "\C-cs" 'rpm-interactive-source)       
					;Source: 
  (define-key rpm-mode-map "\C-cp" 'rpm-interactive-patch)        
					;Patch: 
  (define-key rpm-mode-map "\C-cg" 'rpm-interactive-group)        
					;group Ū
  (define-key rpm-mode-map "\C-cb" 'rpm-interactive-buildroot)    
					;buildroot 
  (define-key rpm-mode-map "\C-cl" 'rpm-interactive-if_defined_buildroot_dumpdir)
					;δؿȤäbuildrootƤȤ
					;buildrootפ
					;("C-c l""l"file list  "l")
  (define-key rpm-mode-map "\C-cB" 'rpm-interactive-subpackages)   
					;subpackage 
  (define-key rpm-mode-map "\C-cD" 'rpm-interactive-description)  
					;%description 
  (define-key rpm-mode-map "\C-cC" 'rpm-interactive-changelog)
					;%changelog 
  (define-key rpm-mode-map "\C-cd" 'rpm-interactive-changelog-date)
					;%changelog date
  (define-key rpm-mode-map "\C-cS" 'rpm-interactive-setupmacro)        
					;%setup ޥ
  (define-key rpm-mode-map "\C-cP"  'rpm-interactive-patchmacro)       
					;%patch ޥ
  (define-key rpm-mode-map "\C-cF" 'rpm-interactive-files)        
					;%files 
  (define-key rpm-mode-map "\C-cI" 'rpm-interactive)      
					;interactive ⡼
  (define-key rpm-mode-map "\C-ch" 'rpm-help)             
					;إץ⡼
  (define-key rpm-mode-map "\C-cr" 'rpm-exec)        
					;rpm ޥɼ¹
  (define-key rpm-mode-map "\C-ct" 'rpm-interactive-install-info)        
					;install-info 
  )

;;-------------------- RPM-mode -------------------------------
(defun rpm-mode ()
  "Major mode for editing SPEC file."
  (interactive)
  (kill-all-local-variables)
  (make-local-variable 'arg)
  (make-local-variable 'other-arg)
  (make-local-variable 'spec-name)
  (make-local-variable 'rpm-process)
  (make-local-variable 'omax)
  (make-local-variable 'mode-line-process)
  (setq mode-name "RPM")
  (setq major-mode 'rpm-mode)
  (use-local-map rpm-mode-map)


;;-------------------- Menu bar ------------------------------
;for mule emacs20
  (if (not (featurep 'xemacs))
      (progn
	(defvar menu-bar-rpm-menu
	  (make-sparse-keymap "RPM"))
	(define-key rpm-mode-map 
	  [menu-bar rpm]
	  (cons "RPM" menu-bar-rpm-menu))
	(define-key menu-bar-rpm-menu
	  [rpm-exec]
	  '("Exec rpm command" . rpm-exec))
	(define-key menu-bar-rpm-menu
	  [rpmline6]
	  '("---------------------------------".() ))
	(define-key menu-bar-rpm-menu
	  [rpm-interactive-variable]
	  '("Env variable" . rpm-interactive-variable))
	(define-key menu-bar-rpm-menu
	  [rpmline5]
	  '("---------------------------------".() ))
	(define-key menu-bar-rpm-menu
	  [rpm-interactive-if_defined_buildroot_dumpdir]
	  '("Dump $BuildRoot" . rpm-interactive-if_defined_buildroot_dumpdir))
	(define-key menu-bar-rpm-menu
	  [rpmline4]
	  '("---------------------------------".() ))
	(define-key menu-bar-rpm-menu
	  [rpm-interactive-install-info]
	  '("Install Info" . rpm-interactive-install-info))
	(define-key menu-bar-rpm-menu
	  [rpmline3]
	  '("---------------------------------".() ))
	(define-key menu-bar-rpm-menu
	  [rpm-interactive-files]
	  '("%files" . rpm-interactive-files))
	(define-key menu-bar-rpm-menu
	  [rpm-interactive-patchmacro]
	  '("%patch" . rpm-interactive-patchmacro))
	(define-key menu-bar-rpm-menu
	  [rpm-interactive-setupmacro]
	  '("%setup" . rpm-interactive-setupmacro))
	(define-key menu-bar-rpm-menu
	  [rpm-interactive-subpackages]
	  '("%package" . rpm-interactive-subpackages))
	(define-key menu-bar-rpm-menu
	  [rpm-interactive-changelog]
	  '("%changelog" . rpm-interactive-changelog))
	(define-key menu-bar-rpm-menu
	  [rpm-interactive-changelog-date]
	  '("insert date for %changelog" . rpm-interactive-changelog-date))
	(define-key menu-bar-rpm-menu
	  [rpm-interactive-description]
	  '("%description" . rpm-interactive-description))
	(define-key menu-bar-rpm-menu
	  [rpm-interactive-buildroot]
	  '("BuildRoot:" . rpm-interactive-buildroot))
	(define-key menu-bar-rpm-menu
	  [rpm-interactive-group]
	  '("Group:" . rpm-interactive-group))
	(define-key menu-bar-rpm-menu
	  [rpm-interactive-patch]
	  '("Patch<n>:" . rpm-interactive-patch))
	(define-key menu-bar-rpm-menu
	  [rpm-interactive-source]
	  '("Source<n>:" . rpm-interactive-source))
	(define-key menu-bar-rpm-menu
	  [rpm-interactive-distribution]
	  '("Distribution:" . rpm-interactive-distribution))
	(define-key menu-bar-rpm-menu
	  [rpm-interactive-vendor]
	  '("Vendor:" . rpm-interactive-vendor))
	(define-key menu-bar-rpm-menu
	  [rpm-interactive-copyright]
	  '("Copyright:" . rpm-interactive-copyright))
	(define-key menu-bar-rpm-menu
	  [rpm-interactive-release]
	  '("Release:" . rpm-interactive-release))
	(define-key menu-bar-rpm-menu
	  [rpm-interactive-version]
	  '("Version:" . rpm-interactive-version))
	(define-key menu-bar-rpm-menu
	  [rpm-interactive-name]
	  '("Name:" . rpm-interactive-name))
	(define-key menu-bar-rpm-menu
	  [rpm-interactive-summary]
	  '("Summary:" . rpm-interactive-summary))
	(define-key menu-bar-rpm-menu
	  [rpmline2]
	  '("---------------------------------".() ))
	(define-key menu-bar-rpm-menu
	  [rpm-sampleform]
	  '("Insert a sample form" . rpm-add-all))
	(define-key menu-bar-rpm-menu
	  [rpmline1]
	  '("---------------------------------".() ))
	(define-key menu-bar-rpm-menu
	  [rpm-interactive]
	  '("Interactive Mode" . rpm-interactive))
	(define-key menu-bar-rpm-menu
	  [rpmline0]
	  '("---------------------------------".() ))
	(define-key menu-bar-rpm-menu 
	  [rpm-help]
	  '("Available tags(HELP)" . rpm-help))
	)
    )
  ;for xemacs
  (if (featurep 'xemacs)
      (progn
	(defvar rpm-mode-popup-menu
	  (purecopy '("RPM"
		      ["Available tags(HELP)" rpm-help t]
		      "---"
		      ["Interactive Mode" rpm-interactive t]
		      "---"
		      ["Insert a sample form" rpm-add-all t]
		      "---"
		      ["Summary:"  rpm-interactive-summary t]
		      ["Name:" rpm-interactive-name t]
		      ["Version:" rpm-interactive-version t]
		      ["Release:" rpm-interactive-release t]
		      ["Copyright:" rpm-interactive-copyright t]
		      ["Vendor:" rpm-interactive-vendor t]
		      ["Distribution:" rpm-interactive-distribution t]
		      ["Source<n>:" rpm-interactive-source t]
		      ["Patch<n>:" rpm-interactive-patch t]
		      ["Group:" rpm-interactive-group t]
		      ["BuildRoot:" rpm-interactive-buildroot t]
		      ["%description" rpm-interactive-description t]
		      ["insert date for %changelog" rpm-interactive-changelog-date t]
		      ["%changelog" rpm-interactive-changelog t]
		      ["%package" rpm-interactive-subpackages t]
		      ["%setup" rpm-interactive-setupmacro t]
		      ["%files" rpm-interactive-files t]
		      "---"
		      ["Install Info" rpm-interactive-install-info t]
		      "---"
		      ["Dump %BuildRoot" rpm-interactive-if_defined_buildroot_dumpdir t]
		      "---"
		      ["Env variable" rpm-interactive-variable t]
		      "---"
		      ["Exec rpm command" rpm-exec t]
		      )
		    ))
	(easy-menu-define rpm-mode-menu rpm-mode-map "" rpm-mode-popup-menu)
	(easy-menu-add rpm-mode-menu)
	)
    )
  (run-hooks 'rpm-mode-hook)
  )
;;-------------------- Commands ------------------------------
;C-c v
(defun rpm-interactive-variable ()
  "Insert a Variable"
  (interactive)
  (message "0)DIRط 1)OPT_FLAGS 2)ARCH 3)OS 4)NAME 5)VERSION 6)RELEASE")
  (let ((ans (char-to-string (read-char))))
    (cond 
     ((string-match "0" ans)
      (message "0)SOURCE_DIR 1)BUILD_DIR 2)DOC_DIR 3)ROOT_DIR 4)BUILD_ROOT 5)INSTALL_PREFIX")
      (let ((ans2 (char-to-string (read-char))))
	(cond
	 ((string-match "0" ans2)
	  (insert "$RPM_SOURCE_DIR"))
	 ((string-match "1" ans2)
	  (insert "$RPM_BUILD_DIR"))
	 ((string-match "2" ans2)
	  (insert "$RPM_DOC_DIR"))
	 ((string-match "3" ans2)
	  (insert "$RPM_ROOT_DIR"))
	 ((string-match "4" ans2)
	  (insert "$RPM_BUILD_ROOT"))
	 ((string-match "5" ans2)
	  (insert "$RPM_INSTALL_PREFIX"))
	 )))
     ((string-match "1" ans)
      (insert "$RPM_OPT_FLAGS"))
     ((string-match "2" ans)
      (insert "$RPM_ARCH"))
     ((string-match "3" ans)
      (insert "$RPM_OS"))
     ((string-match "4" ans)
      (insert "$RPM_PACKAGE_NAME"))
      ((string-match "5" ans)
       (insert "$RPM_PACKAGE_VERSION"))
      ((string-match "6" ans)
       (insert "$RPM_PACKAGE_RELEASE"))
      ))
  )



;; C-c a
(defun rpm-add-all ()
  "Add all tags"
  (interactive)
  (save-excursion
    (insert "Summary: \n")
    (insert "Name: \n")
    (insert "Version: \n")
    (insert "Release: \n")
    (insert "Copyright: \n")
    (insert "Distribution: " distribution "\n")
    (insert "Vendor: " vendor "\n")
    (insert "Group: \n")
    (insert "Source: \n")
    (insert "Patch: \n")
    (if (boundp 'packager)
        (insert "Packager: " packager"\n")
      (insert "Packager: \n"))
    (insert "URL: \n")
    (if (boundp 'buildrootroot)
	(insert "BuildRoot: " buildrootroot "/\n")
      (insert "BuildRoot: \n"))
    (insert "\n")
    (insert "%description\n")
    (insert "\n")
    (insert "%changelog\n")
    (insert "\n")
    (insert "%prep\n")
    (insert "\n")    
    (insert "%setup \n")
    (insert "%patch -p1\n")
    (insert "\n")
    (insert "%build\n")
    (insert "\n")
    (insert "%install\n")
    (insert "\n")
    (insert "%clean\n")
    (if (boundp 'buildroot)
	(insert "rm -rf $RPM_BUILD_ROOT\n"))
    (insert "\n") 
    (insert "%pre\n")
    (insert "\n")
    (insert "%post\n")
    (insert "\n")
    (insert "%preun\n")
    (insert "\n")
    (insert "%postun\n")
    (insert "\n")
    (insert "%files \n")  
    (insert "\n")
    (insert "%doc \n") 
    )
)

;C-c h
(defun rpm-help ()
  "Display all available spec tags."
  (interactive)
  (with-output-to-temp-buffer "*Available Tags & Scripts in SPEC FILE*"
    (princ "========== ץꥢ֥롦 ==========\n")
    (princ "Name:                   |(ץ̾)\n")
    (princ "Version:                |(ץΥС)\n")
    (princ "Release:                |(rpm ѥåΥ꡼ֹ)\n")
    (princ "Serial: <num>           |(ѥåΥꥢֹ)\n")
    (princ "%define                 |(̾\n")
    (princ "                        | : %define version %{PACKAGE_VERSION}\n")
    (princ "                        | ʹ%{version}%{PACKAGE_VERSION}Ѳǽ)\n") 
    (princ "Summary:                |(ѥå())\n")
    (princ "Summary(lang):          |(langˤѥå())\n")
    (princ "Copyright:              |(ɽ(GPL,MIT,etc)\n")
    (princ "Distribution:           |(۷̾(ۤѥå̾))\n")
    (princ "Icon:                   |(̾,glintǻѤ)\n")
    (princ "Vendor:                 |(٥̾)\n")
    (princ "URL:                    |(ΥץˤĤƤξ URL)\n")
    (princ "Group:                  |(Υѥå°륰롼̾)\n")
    (princ "Packager:               |(ѥå̾)\n")
    (princ "%description [-l <lang>]|(ѥåˤĤƤξܺ٤(ʣԲ))\n")
    (princ "%changelog              |(ѹ\n")
    (princ "                        |եޥå *    ǯ ̾ <e-mail adress\n")
    (princ "                        |             - ѹȤ\n")
    (princ "Source[<n>]:            |(ץΥ̾)\n")
    (princ "Patch[<n>]:             |(ץΥѥå̾)\n")
    (princ "NoSource: [<n>]         |(src.rpmѥå˴ޤ᤿ʤ̾) \n")
    (princ "NoPatch: [<n>]          |(src.rpmѥå˴ޤ᤿ʤѥå̾)\n")
    (princ "ExcludeArch: <arch>     |(<arch>ǤϥѥåǤʤ)\n")
    (princ "ExclusiveArch: <arch>   |(<arch>ǤΤߥѥåǤ)\n")
    (princ "ExcludeOS: <os>         |(<os>ǤϥѥåǤʤ)\n")
    (princ "ExclusiveOS: <os>       |(<os>ǤΤߥѥåǤ)\n")
    (princ "Prefix: <path>          |(󥹥ȡѥƬ)\n")
    (princ "Prefixes: <path>...     |(󥹥ȡѥƬʣ(򤢤ƻ))\n")
    (princ "BuildRoot: <path>       |(ѥåβ󥹥ȡ)\n")
    (princ "BuildConflicts:         |(ѥå˶礹ѥå)\n")
    (princ "BuildRequires:          |(ѥåɬפȤʤѥåե)\n")
    (princ "BuildArchitectures:     |(ѥåμ(i386,noarch,...)ꤹ)\n")
    (princ "Provides:               |(ۥѥå󶡤)\n")
    (princ "Requires:               |(¾ɬפʥѥå̾(<,>,=,>=,<=,Ѳ))\n")
    (princ "Conflicts:              |(礹ѥå̾(<,>,=,>=,<=,Ѳ))\n")
    (princ "PreReq:                 |(%pre,%post,%postun,%preunǼ¹Ԥ륳ޥ\n")
    (princ "                        | 󥹥ȡͽɬפʥޥɤ⤷ϥѥå̾)\n")
    (princ "AutoReqProv: (yes|no)   |(ѥå˰¸/ǽ󶡥å򤹤뤫)\n")
    (princ "AutoReq: (yes|no)       |(ѥå˰¸å򤹤뤫)\n")
    (princ "AutoProv: (yes|no)      |(ѥå˵ǽ󶡥å򤹤뤫)\n")
    (princ "DocDir: <dir>           |(ʸǥ쥯ȥ /usr/doc  <dir>ѹ)\n")
    (princ "%package [-n] <name>    |(ʣΥѥåȤΥѥå̾)\n")
    (princ "\n")
    (princ "===== Build Script  & Ķѿ ====\n")
    (princ "%prep                   |(RPMӥɻΥåԤץ)\n")
    (princ "%setup                  |(Ÿ뤿Υޥ)\n")
    (princ "   -n <name>            ||(Ÿ cd Υǥ쥯ȥ̾)\n")
    (princ "   -c                   ||(Ÿ cd Υǥ쥯ȥ)\n")
    (princ "   -D                   ||(ŸŸǥ쥯ȥõʤ\n")
    (princ "                        || -a  -b -T ץȤȤ˻Ȥ뤳Ȥ¿)\n")
    (princ "   -T                   ||(ŸȤ Source0 ƤŸʤ\n")
    (princ "                        || -a  -b -D ץȤȤ˻Ȥ뤳Ȥ¿)\n")
    (princ "   -b <n>               ||(nܤΥŸ)\n")
    (princ "   -a <n>               ||(nܤΥŸ)\n")
    (princ "%patch                  |(ѥåƤ뤿Υޥ)\n")
    (princ "   -P <n>               ||(Patch<n> 򤢤Ƥʤ)\n")
    (princ "   -p <n>               ||(patch ޥɤ -p ץƱ)\n")
    (princ "   -b <name>            ||(ѥåƤΥե̾ղäĥҤ \n")
    (princ "                        ||.orig ǤϤʤ<name> ˤ)\n")
    (princ "   -E                   ||(ѥåƤ夫ˤʤäե)\n")
    (princ "%build                  |(ºݤ˥ץ뤿Υ(make򵭽))\n")
    (princ "%configure              |(configuer ץȤ¹)\n")
    (princ "%install                |(󥹥ȡ˹ԤȤ򵭽 (make install))\n")
    (princ "%clean                  |(ӥɤǥ쥯ȥĥ꡼õ\n")
    (princ "                        | Ȥʤɤ򵭽Ҥ    : rm -rf  $RPM_BUILD_ROOT)\n")
    (princ "$RPM_SOURCE_DIR         |(ե֤ǥ쥯ȥ) \n")
    (princ "                        | ǥե:/usr/src/redhat/SOURCES\n")
    (princ "$RPM_BUILD_DIR          |(ӥɻ˻Ȥǥ쥯ȥ)\n")
    (princ "                        | ǥե:/usr/src/redhat/BUILD\n")
    (princ "$RPM_DOC_DIR            |(ɥȤ֤ǥ쥯ȥ)\n")
    (princ "                        | ǥե:/usr/doc\n")
    (princ "$RPM_OPT_FLAGS          |(rpmrc  makeʤɤΥץʥե饰)\n")
    (princ "$RPM_ARCH               |(ѥåӥɤоݤΥƥ)\n")
    (princ "$RPM_OS                 |(ѥåӥɤоݤ OS)\n")
    (princ "$RPM_ROOT_DIR           |(ѥåΥ롼ȥǥ쥯ȥȤʤ\n")
    (princ "                        | $RPM_BUILD_ROOT ˤϤΥǥ쥯ȥ)\n")
    (princ "$RPM_BUILD_ROOT         |(Ū˥󥹥ȡ뤹Υ롼ȥǥ쥯ȥ)\n")
    (princ "$RPM_PACKAGE_NAME       |(Name: ǻꤷ̾)\n")
    (princ "$RPM_PACKAGE_VERSION    |(Version: ǻꤷС)\n")
    (princ "$RPM_PACKAGE_RELEASE    |(Release: ǻꤷ꡼)\n")
    (princ "\n")
    (princ "= 󥹥ȡ Script  & Ķѿ =\n")
    (princ "%pre [-p]               |(ѥå򥤥󥹥ȡ뤹ˤ뤳Ȥ򵭽)\n")
    (princ "%post [-p]              |(ѥå򥤥󥹥ȡ뤷ˤ뤳Ȥ򵭽)\n")
    (princ "%preun [-p]             |(ѥå򥢥󥤥󥹥ȡ뤹ˤ뤳Ȥ򵭽)\n")
    (princ "%postun [-p]            |(ѥå򥢥󥤥󥹥ȡ뤷ˤ뤳Ȥ򵭽)\n")
    (princ "%verifyscript           |(ѥåξȹ(verify)˼¹Ԥ륹ץ\n")
    (princ "%trigger{un|in|postun} [[-n] <subpackage>] [-p <program>] -- <trigger> | \n")
    (princ "                    (<trigger>installuninstallpostuninstall\n")
    (princ "                      ѹɬפ礽ư򵭽Ҥ롥<=>Ѳ)\n")
    (princ "$RPM_INSTALL_PREFIX     |(ѥå󥹥ȡΥѥƬ)\n")
    (princ "\n")
    (princ "====== եꥹ  ======\n")
    (princ "%files                  |(󥹥ȡ뤹ե) \n")
    (princ "   -f <file>            |(󥹥ȡ뤵եꥹȤ<file>)\n")
    (princ "   -n <name>            |(֥ѥå<name>Υեꥹ)\n")
    (princ "%doc <file>             |(ɥȥե <file>)\n")
    (princ "%config <file>          |(եʤɥ󥹥ȡθ˹)\n")
    (princ "%config(missingok) <file> |(%configʥեǤ¸ߤƤʤƤɤ)\n")
    (princ "%config(noreplace) <file> |(%configʥեǤ֤ƤϤʤ)\n")
    (princ "%docdir <dir>           |(ɥȥǥ쥯ȥ)\n")
    (princ "%dir <dir>              |(ѥåΤߤȤǥ쥯ȥ)\n")
    (princ "%ghost <file>           |(ˤȤϸ¤ʤե(եʤ)\n")
    (princ "%lang()                 |(°եꤹ)\n")
    (princ "%attr(<mode>,<user>,<group>) <file>| \n")
    (princ "               (RPMˤäƾȹ礵룹ĤΥե°Υȥ)\n")
    (princ "               (̥桼ѥåȤʤɤǤϡ\n")
    (princ "                󥹥ȡ%doc Ԥ°ˤʤΤɤ\n")
    (princ "                Ѥ롥)\n")
    (princ "%defattr(<mode>,<usr>,<group>)     | \n")
    (princ "               (%defattr()ʲ󤵤ƤƤΥե\n")
    (princ "                ⤷¾%defattr()ФƤޤǤΥǥե\n")
    (princ "                °ꤹ롥Ĥޤ\n")
    (princ "                ʣΥեǽ %attr()\n")
    (princ "%verify([not]<attr>...) <file> |\n")
    (princ "               (RPMեȹ礹Ȥɬפ°ޤ\n")
    (princ "                åʤ褦˥å°\n")
    (princ "%defverify()                    \n")
    (princ "               (%defverify()ʲƤΥե(⤷\n")
    (princ "                ¾%defverify()ФƤޤ)Υǥե\n")
    (princ "                ѥ᡼ꤹ롥Ĥޤ\n")
    (princ "                ʣΥեǽ%verify()\n")
    (princ "\n")
    (princ "====== ʸ(ʳˤ sh ʸѲǽ) ======\n")
    (princ "%ifarch <arch> \n")
    (princ "%ifnarch <arch> \n")
    (princ "%ifos <os> \n")
    (princ "%ifnos <os> \n")
    (princ "%else \n")
    (princ "%endif \n")
    (princ "======= ¾ =======\n")
    (princ "-p ץ\n")
    (princ "%pre*/post* Ȥ -p <ץΥѥ>ꤵƤ\n")
    (princ "줬¹Ԥ롣 -p ǻꤵ줿ץ prerequisite\n")
    (princ "ȤϿ(Ǥʤ /bin/sh)\n")
    ))

;;==========================================================================
;; 󥿥饯ƥ֤ʥ=============================================
;;==========================================================================
;; C-c I
(defun rpm-interactive ()
  "Interactive Inserting Tags"
  (interactive)
  (rpm-interactive-summary)
  (rpm-interactive-name)
  (rpm-interactive-version)
  (rpm-interactive-release)
  (rpm-interactive-copyright)
  (rpm-interactive-distribution)
  (rpm-interactive-vendor)
  (rpm-interactive-group) 
  (rpm-interactive-source)
  (rpm-interactive-patch)
  (rpm-interactive-url)
  (rpm-interactive-packager)
  (rpm-interactive-icon)
  (rpm-interactive-buildroot)
  (rpm-interactive-buildarchitectures)
  (rpm-interactive-preambletags)
  (rpm-interactive-description)
  (rpm-interactive-changelog)
  (rpm-interactive-subpackages)

  ;(message "Going Build Script Environment tags...")
  (message "Build ץȤޤ")

  (insert "%prep\n")

  (rpm-interactive-setupmacro)
  (rpm-interactive-patchmacro)

  (rpm-interactive-if_defined_buildroot)
  (rpm-interactive-build)
  (rpm-interactive-install)
  (rpm-interactive-clean)

  ;(message "Going Install-Time Script Environment tags...")
  (message "󥹥ȡΥץȤޤ")

  (rpm-interactive-install_time_script)

  ;(message "Going File list Directives tags...")
  (message "եꥹȤޤ")

  (rpm-interactive-files)

  (message "Interactive mode done ...")
  )

;---------------------------------------
;----- 󥿥饯ƥֻؿ-----
;---------------------------------------

; Summary 
(defun rpm-interactive-summary ()
  "Insert a Summary interactively"
  (interactive)
  ;(setq summary (read-string "Please insert Summary: ")) 
  (setq summary (read-string "Summary ϤƤ=> ")) 
  (insert "Summary: " summary"\n")
  )

;Name 
(defun rpm-interactive-name ()
  "Insert a Name interactively"
  (interactive)
  ;(setq name (read-string "Please insert Name: ")) 
  (setq name (read-string "Name ϤƤ=> ")) 
  (insert "Name: " name"\n")
  )

; Version 
(defun rpm-interactive-version ()
  "Insert a Version interactively"
  (interactive)
  ;(setq version (read-string "Please insert Version: ")) 
  (setq version (read-string "Version ϤƤ=> ")) 
  (insert "Version: " version"\n")
  )

;Release 
(defun rpm-interactive-release ()
  "Insert a Release interactively"
  (interactive)
  ;(setq release (read-string "Please insert Release: ")) 
  (setq release (read-string "Release ϤƤ=> ")) 
  (insert "Release: " release"\n")
  )

;Copyright 
(defun rpm-interactive-copyright ()
  "Insert a Copyright tag interactively"
  (interactive)
  (message "Copyright:0)GPL 1)BSD 2)MIT 3)Distributable 4)PublicDomain 5)non-free 6)Others")
  (let ((ans (char-to-string (read-char))))
    (cond
     ((string-match "0" ans)
      (insert "Copyright: GPL\n"))
     ((string-match "1" ans)
      (insert "Copyright: BSD\n"))
     ((string-match "2" ans)
      (insert "Copyright: MIT\n"))
     ((string-match "3" ans)
      (insert "Copyright: Distributable\n"))
     ((string-match "4" ans)
      (insert "Copyright: Public Domain\n"))
     ((string-match "5" ans)
      (insert "Copyright: Non-free\n"))
     ((string-match "6" ans)
      ;(setq copyright (read-string "Please insert Copyright: ")) 
      (setq copyright (read-string "Copyright ϤƤ=> ")) 
      (insert "Copyright: " copyright"\n"))
     (t (insert "Copyright: \n"))
     ))
  )
    
(defun rpm-interactive-distribution ()
  "Insert a Distribution tag interactively"
  (interactive)
  ;(message "Do you want to insert a Distribution tag ? Y)es N)o : ")
  (message "Distribution 񤭤ޤ Y)es N)o : ")
  (let ((ans (char-to-string (read-char))))
    (cond
     ((string-match "y" ans)
      (if (y-or-n-p (concat "Distribution: " distribution " OK? "))
	  t
	;(setq distribution(read-string "Please insert Distribution: ")))
	(setq distribution(read-string "Distribution ϤƤ=> ")))
      (insert "Distribution: " distribution"\n"))
     ((string-match "n" ans)
      (message "Distribution tag skipped!"))
     (t (message "Distribution tag skipped!"))
       )
    )
  )

;Group tag
(defun rpm-interactive-group () 
  "0)Amu  means  Amusements.
1)App  means  Applications.
2)Dev  means  Development.
3)Doc  means  Documentation.
4)Sys  means  System Environment.
6)UI   means  User Interface.
b)Ex   means  Extensions."
  (interactive)
  (message "Group: 0)Amu 1)App 2)Dev 3)Doc 4)Sys 5)UI 6)Ex")
  (let ((ans (char-to-string (read-char))))
    (cond
     ((string-match "0" ans)
      (rpm-group-tag-amusements))
     ((string-match "1" ans)
      (rpm-group-tag-applications))
     ((string-match "2" ans)
      (rpm-group-tag-development))
     ((string-match "3" ans)
      (rpm-group-tag-documentation))
     ((string-match "4" ans)
      (rpm-group-tag-system-environment))
     ((string-match "5" ans)
      (rpm-group-tag-user-interface))
     ((string-match "6" ans)
      (rpm-group-tag-extensions))
     (t (insert "Group: \n"))
     ))
  )

;Group: Amusements/
(defun rpm-group-tag-amusements ()
  "0)Games  means Games.
1)Graphics means Graphics
2)Other    means Other."
  (interactive)
  (message "0)Games 1)Graphics")
  (let ((ans (char-to-string (read-char))))
    (cond
     ((string-match "0" ans)
      (insert "Group: Amusements/Games\n"));0
     ((string-match "1" ans)
      (insert "Group: Amusements/Graphics\n"));1
     ((string-match "2" ans)
      (insert "Group: Amusements\n"));d
     (t (insert "Group: Amusements\n"))
     ))
  )


;Group: Applications/
(defun rpm-group-tag-applications ()
  "0)Arc    means  Archiving.
1)Com    means  Communications.
2)Db     means  Databases.
3)Edtr   means  Editors.
4)Emu    means  Emulators.
5)Eng    means  Engineering.
6)File   means  File. :-)
7)Inet   means  Internet.
8)Mm     means  Multimedia.
9)Prod   means  Productivity.
a)Pub    means  Publishing.
b)Sys    means  System
c)Txt    means  Text
d)Oths   means  Others. (You must insert a tag yourself.)"
  (interactive)
  (message 
   "0)Arc 1)Com 2)Db 3)Edtr 4)Emu 5)Eng 6)File 7)Inet 8)Mm 9)Prod a)Pub b)Sys c)Txt d)Oths")
  (let ((ans (char-to-string (read-char))))
    (cond
     ((string-match "0" ans)
      (insert "Group: Applications/Archiving\n"));0
     ((string-match "1" ans)
      (insert "Group: Applications/Communications\n"));1
     ((string-match "2" ans)
      (insert "Group: Applications/Databases\n"));2
     ((string-match "3" ans)
      (insert "Group: Applications/Editors\n"));3
     ((string-match "4" ans)
      (insert "Group: Applications/Emulators\n"));4
     ((string-match "5" ans)
      (insert "Group: Applications/Engineering\n"));5
     ((string-match "6" ans)
      (insert "Group: Applications/File\n"));6
     ((string-match "7" ans)
      (insert "Group: Applications/Internet\n"));7
     ((string-match "8" ans)
      (insert "Group: Applications/Multimedia\n"));8
     ((string-match "9" ans)
      (insert "Group: Applications/Productivity\n"));9
     ((string-match "a" ans)
      (insert "Group: Applications/Publishing\n"));a
     ((string-match "b" ans)
      (insert "Group: Applications/System\n"));b
     ((string-match "c" ans)
      (insert "Group: Applications/Text\n"));c
     ((string-match "d" ans)
      (insert "Group: Applications\n"));d
     (t (insert "Group: Applications\n"))
     ))
  )

;Group:Development/
(defun rpm-group-tag-development ()
  "0)Debbugers  means  \"Development/Debbugers\".
1)Languages  means  \"Development/Languages\".
2)Libraries  means  \"Development/Libraries\".
3)System     means  \"Development/System\".
4)Tools      means  \"Development/Tools\".
5)Others     means  Others. (You must insert a tag yourself.)"
  (interactive)
  (message "0)Debbugers 1)Languages 2)Libraries 3)System 4)Tools 5)Others")
  (let ((ans (char-to-string (read-char))))
    (cond
     ((string-match "0" ans)
      (insert "Group: Development/Debbugers\n"))
     ((string-match "1" ans)
      (insert "Group: Development/Languages\n"))
     ((string-match "2" ans)
      (insert "Group: Development/Libraries\n"))
     ((string-match "3" ans)
      (insert "Group: Development/System\n"))
     ((string-match "4" ans)
      (insert "Group: Development/Tools\n"))
     ((string-match "5" ans)
      (insert "Group: Development\n"))
     (t (insert "Group: Development\n"))
     ))
  )

;Group: Documentaion/
(defun rpm-group-tag-documentation ()
  "Insert \"Group: Documentation\"."
  (interactive)
  (insert "Group: Documentation\n")
  )

;Group: System Environment/
(defun rpm-group-tag-system-environment ()
  "0)Base  means Base.
1)Daemons  means Daemons.
2)Kernel   means Kernsl.
3)Lib      means Libraries.
4)Shell   means Shells.
5)Other    means Other."
  (interactive)
  (message "0)Base 1)Daemons 2)Kernel 3)Lib 4)Shell 5)Other")
  (let ((ans (char-to-string (read-char))))
    (cond
     ((string-match "0" ans)
      (insert "Group: System Environment/Base\n"));0
     ((string-match "1" ans)
      (insert "Group: System Environment/Daemons\n"));1
     ((string-match "2" ans)
      (insert "Group: System Environment/Kernel\n"));2
     ((string-match "3" ans)
      (insert "Group: System Environment/Libraries\n"));3
     ((string-match "4" ans)
      (insert "Group: System Environment/Shells\n"));4
     ((string-match "5" ans)
      (insert "Group: System Environment\n"));5
     (t (insert "Group: System Environment\n"))
     ))
  )

;Group: User Interface/
(defun rpm-group-tag-user-interface ()
  "0)desktops  means Desktops.
1)X        means X.
2)X hard   means X Hardware Support.
4)Other    means Other."
  (interactive)
  (message "0)desktops 1)X  2)X hard 3)Other")
  (let ((ans (char-to-string (read-char))))
    (cond
     ((string-match "0" ans)
      (insert "Group: User Interface/Desktops\n"));0
     ((string-match "1" ans)
      (insert "Group: User Interface/X\n"));1
     ((string-match "2" ans)
      (insert "Group: User Interface/X hardware Support\n"));2
     ((string-match "3" ans)
      (insert "Group: User Interface\n"));3
     (t (insert "Group: User Interface\n"))
     ))
  )

;Group: Extensions/
(defun rpm-group-tag-extensions ()
"0)Japanese  means  \"Extensions/Japanese\".
 1) Others   means  Others. (You must insert a tag yourself.)"
  (interactive)
  (message "0)Japanese 1)Others")
  (let ((ans (char-to-string (read-char))))
    (cond
     ((string-match "0" ans)
      (insert "Group: Extensions/Japanese\n"))
     ((string-match "1" ans)
      (insert "Group: Extensions\n"))
     (t (insert "Group: Extensions\n"))
     ))
  )

(defun rpm-interactive-source ()
  "Insert the Source<n> interactively"
  (interactive)
  (setq nums 0)
  (setq multiplesource "y")
  (while (string-match "y" multiplesource)
    ;(setq source (read-string "Please insert the source name: "))
    (setq source (read-string "ե̾ϤƤ=> "))
    (insert (format "Source%d: %s \n" nums source))
    ;(message "Need more sources ? Y)es N)o :")
    (message "¾˥եϤޤ Y)es N)o :")
    (if (string-match "y" (char-to-string (read-char)))
	(progn (setq multiplesource "y") (setq nums (+ nums 1)))
      (setq multiplesource "n")
      )
    )
  )
(defun rpm-interactive-patch ()
  "Insert the Patch<n> interactively"
  (interactive)
  (setq nump 0)
  (setq multiplepatch "y")
  ;(message "Do you need to insert a patch ? Y)es N)o :")
  (message "ѥåɬפǤ Y)es N)o :")
  (if (string-match "y" (char-to-string (read-char)))
      (while (string-match "y" multiplepatch)
	;(setq patch (read-string "Please insert the patch name: "))
	(setq patch (read-string "ѥåե̾ϤƤ=> "))
	(insert (format "Patch%d: %s \n" nump patch))
	;(message "Need more patches ? Y)es N)o :")
	(message "˥ѥåɬפǤ Y)es N)o :")
	(if (string-match "y" (char-to-string (read-char)))
	    (progn (setq multiplepatch "y") (setq nump (+ nump 1)))
	  (setq multiplepatch "n")
	  )
	)
    (setq nump -1)
    )
  )
  
;Vendor 
(defun rpm-interactive-vendor ()
  "Insert a Vendor tag interactively"
  (interactive)
  ;(message "Do you want to insert a Vendor tag ? Y)es N)o: ")
  (message "Vendor ɬפǤ Y)es N)o: ")
  (let ((ans (char-to-string (read-char))))
    (cond
     ((string-match "y" ans)
      (if (y-or-n-p (concat "Vendor: " vendor " OK? "))
	  t
	;(setq vendor(read-string "Please insert Vendor: ")))
	(setq vendor(read-string "Vendor ̾ϤƤ=> ")))
      (insert "Vendor: " vendor "\n"))
     ((string-match "n" ans)
      (message "Vendor tag skipped!"))
     (t (message "Vendor tag skipped!"))
       )
    )
  )

;URL 
(defun rpm-interactive-url ()
  "Insert the URL interactively"
  (interactive)
  ;(message "Do you want to insert URL ? Y)es N)o :")
  (message "URL ޤ Y)es N)o :")
  (let ((ans (char-to-string (read-char))))
    (cond
     ((string-match "y" ans)
      (rpm-url-tag))
     ((string-match "n" ans)
      (message "No URL"))
     (t (message "skipped an url tag!"))
     ))
  )
;URL Υ֥롼(URL)
(defun rpm-url-tag ()
  "Subroutine for rpm-interactive-rul"
  (interactive)
  ;(setq url (read-string "Please insert url name=> "))
  (setq url (read-string "URL ϤƤ=> "))
  (insert "URL: " url"\n")
  )
;Packager 
(defun rpm-interactive-packager ()
  "Insert the Packager interactively"
  (interactive)
  (if (boundp 'packager)
      (insert "Packager: " packager"\n")
    (progn
      ;(defvar packager (read-string "Please insert Packager: "))
      (defvar packager (read-string "Packager ̾ϤƤ=> "))
      (insert "Packager: " packager"\n"))
    )
  )

;Icon 
(defun rpm-interactive-icon ()
  "Insert the Icon interactively"
  (interactive)
  ;(message "Icon exist ? Y)es  N)o :") ; Icon 
  (message "Icon ޤ Y)es  N)o :") ; Icon 
  (let ((ans (char-to-string (read-char))))
    (cond 
     ((string-match "y" ans)
      (rpm-icon-tag))
     ((string-match "n" ans)
      (message "No icons"))
     (t (message "skipped icon tag!"))
     ))
  )
;Icon Υ֥롼(̾)
(defun rpm-icon-tag ()
  "Subroutine for rpm-interactive-icon"
  (interactive)
  ;(setq icon (read-string "Please insert icon name: "))
  (setq icon (read-string "Icon ̾ϤƤ=> "))
  (insert "Icon: " icon"\n")
  )
;BuildRoot 
(defun rpm-interactive-buildroot ()
  "Insert the BuildRoot interactively"
  (interactive)
  ;(message "Do you want to use BuildRoot tag ? Y)es N)o :") ;BuildRoot 
  (message "BuildRoot դޤ Y)es N)o :") ;BuildRoot 
  (let ((ans (char-to-string (read-char))))
    (cond
     ((string-match "y" ans)
      (message "BuildRoot: ")
      (if (boundp 'buildrootroot)
	  (setq buildroot (concat buildrootroot "/" name)))
      (if (boundp 'buildroot)
	  (insert "BuildRoot: " buildroot "\n");
	(progn
	  (setq buildroot (read-string "BuildRoot: "))
	  (insert "BuildRoot: " buildroot"\n"))
	))
     ((string-match "n" ans)
      (makunbound 'buildroot )
      (message "No BuildRoot"))
     (t (message "skipped BuildRoot tag!"))
     ))
 )
;BuildArchitectures 
(defun rpm-interactive-buildarchitectures ()
  "Insert the BuildArchitectures interactively"
  (interactive)
  ;(message "Do you want to use BuildArchitectures tag ? Y)es N)o :")
  (message "BuildArchitectures ɬפǤ Y)es N)o :")
  (let ((ans (char-to-string (read-char))))
    (cond
     ((string-match "y" ans)
;      (message "BuildArchitectures: ")
      (message "0)noarch 1)alpha 2) i386 3)ppc 4)sparc 5)¾")
      (let ((ansba (char-to-string (read-char))))
	(cond 
	 ((string-match "0" ansba)
	  (insert "BuildArchitectures: noarch\n"))
	 ((string-match "1" ansba)
	  (insert "BuildArchitectures: alpha\n"))
	 ((string-match "2" ansba)
	  (insert "BuildArchitectures: i386\n"))
	 ((string-match "3" ansba)
	  (insert "BuildArchitectures: ppc\n"))
	 ((string-match "4" ansba)
	  (insert "BuildArchitectures: sparc\n"))
	 ((string-match "5" ansba)
	  (setq buildarchitectures (read-string "BuildArchitectures: "))
	  (insert "BuildArchitectures: " buildarchitectures"\n"))
	 )))
     ((string-match "n" ans)
      (message "No BuildArchitectures"))
     (t (message "skipped BuildArchitectures tag!"))
     ))
  )
;¾Υץꥢ֥륿
(defun rpm-interactive-preambletags ()
  "Insert another preambles"
  (interactive)
  ;(message "Do you want to use any other Preamble tags ? Y)es N)o :")
  (message "¾Υץꥢ֥륿ɬפǤ Y)es N)o :")
  (let ((ans (char-to-string (read-char))))
    (cond
     ((string-match "y" ans)
      (rpm-preamble-tag))
     ((string-match "n" ans)
      (message "No use any other tags."))
     (t (message "skipped any other Preamble tags"))
     ))
  )
;¾Υץꥢ֥륿Υ֥롼
(defun rpm-preamble-tag ()
  "Subroutine for rpm-interactive-preamvlestags"
  (interactive)
  (message "0)Ex 1)Prefix 2)Provides 3)Requires 4)Serial 5)Conflicts 6)Req/Prov 7)¾")
  (let ((ans (char-to-string (read-char))))
    (cond
     ((string-match "0" ans)
      (message "a)ExcludeArch b)ExclusiveArch c)ExcludeOS d)ExclusiveOS")
      (let ((ans2 (char-to-string (read-char))))
	(cond
	 ((string-match "a" ans2)
	  (setq excludearch (read-string "ExcludeArch:<arch> "))
	  (insert "ExcludeArch: " excludearch"\n"))
	 ((string-match "b" ans2)
	  (setq exclusivearch (read-string "ExclusiveArch:<arch> "))
	  (insert "ExclusiveArch: " exclusivearch"\n"))
	 ((string-match "c" ans2)
	  (setq excludeos (read-string "ExcludeOS:<os> "))
	  (insert "ExcludeOS: " excludeos"\n"))
	 ((string-match "d" ans2)
	  (setq exclusiveos (read-string "ExclusiveOS:<os> "))
	  (insert "ExclusiveOS: " exclusiveos"\n"))
	 )))
     ((string-match "1" ans)
      (message "a)Prefix: b)Prefixes")
      (let ((ansprefix (char-to-string (read-char))))
	(cond
	 ((string-match "a" ansprefix)
	  (setq prefix (read-string "Prefix:<path> "))
	  (insert "Prefix: " prefix"\n"))
	 ((string-match "b" ansprefix)
	  (setq prefixes (read-string "Prefixes: "))
	  (insert "Prefixes: " prefixes"\n"))
	 )))
     ((string-match "2" ans)
      (setq provides (read-string "Provides: "))
      (insert "Provides: " provides"\n"))
     ((string-match "3" ans)
      (setq requires (read-string "Requires: "))
      (insert "Requires: " requires"\n"))
     ((string-match "4" ans)
      (setq serial (read-string "Serial:<num> "))
      (insert "Serial: " serial"\n"))
     ((string-match "5" ans)
      (setq conflicts (read-string "Conflicts: "))
      (insert "Conflicts: " conflicts"\n"))
     ((string-match "6" ans)
      (message "a)AutoReqProv b)AutoReq c)AutoProv")
      (let ((ansauto (char-to-string (read-char))))
	(cond
	 ((string-match "a" ansauto)
	  (setq autoreqprov (read-string "AutoReqProv:{yes|no} "))
	  (insert "AutoReqProv: " autoreqprov"\n"))
	 ((string-match "b" ansauto)
	  (setq autoreq (read-string "AutoReq:{yes|no} "))
	  (insert "AutoReq: " autoreq"\n"))
	 ((string-match "c" ansauto)
	  (setq autoprov (read-string "AutoProv:{yes|no} "))
	  (insert "AutoProv: " autoprov"\n")))))
     ((string-match "7" ans)
      (message "a)Obsoletes b)Docdir c)PreReq")
      (let ((ansetc (char-to-string (read-char))))
	(cond
	 ((string-match "a" ansetc)
	  (setq obsoletes (read-string "Obsoletes: "))
	  (insert "Obsoletes: " obsoletes"\n"))
	 ((string-match "b" ansetc)
	  (setq docdir (read-string "Docdir: "))
	  (insert "Docdir: " docdir"\n"))
	 ((string-match "c" ansetc)
	  (setq prereq (read-string "PreReq: "))
	  (insert "PreReq: " prereq"\n"))
	 )))
     )))

;%description 
(defun rpm-interactive-description ()
  "Insert %description"
  (interactive)
  (insert "\n%description\n\n\n")
  )
;%changelog 
(defun rpm-interactive-changelog ()
  "Insert %changelog"
  (interactive)
  (insert "%changelog \n")
  (if (boundp 'packager)
      (progn
	(setq time (current-time-string))
	(setq year (substring time -4 nil))
	(setq today (substring time 0 11))
	(setq date (concat today year))
	(insert "* " date " " packager"\n")
	(insert "- \n")
	(insert "\n"))
    (progn
      ;(defvar packager (read-string "Please insert Packager: "))
      (defvar packager (read-string "Packager ̾ϤƤ=> "))
      (setq time (current-time-string))
	(setq year (substring time -4 nil))
	(setq today (substring time 0 11))
	(setq date (concat today year))
	(insert "* " date " " packager"\n")
	(insert "- \n")
	(insert "\n"))
    )
  )

;%changelog Ѥdate
(defun rpm-interactive-changelog-date ()
  "insert date for %changelog"
  (interactive)
  (if (boundp 'packager)
      (progn
	(setq time (current-time-string))
	(setq year (substring time -4 nil))
	(setq today (substring time 0 11))
	(setq date (concat today year))
	(insert "* " date " " packager"\n")
;	(insert "- \n"))
	)
    (progn
      ;(defvar packager (read-string "Please insert Packager: "))
      (defvar packager (read-string "Packager ̾ϤƤ=> "))
      (setq time (current-time-string))
	(setq year (substring time -4 nil))
	(setq today (substring time 0 11))
	(setq date (concat today year))
	(insert "* " date " " packager"\n")
	(insert "- \n"))
    )
  )

;ʣΥѥåĤΥ
(defun rpm-interactive-subpackages ()
  "Insert tags for subpackages"
  (interactive)
  (message "֥ѥåĤޤ Y)es N)o :") ;̥ѥåĤ뤫
  (let ((ans (char-to-string (read-char))))
    (cond
     ((string-match "y" ans)
      (rpm-subpackages ans))
     ((string-match "n" ans)
      (insert "\n"))
     (t (insert "\n"))
     ))
  )

;ʣΥѥåĤΥ(%package)
(defun rpm-subpackages (subpackages)
  "Subroutine for rpm-interactive-subpackages"
  (interactive)
;  (defvar subpackages "y")
  (while (string-match "y" subpackages)
    ;(setq packname (read-string "Please insert a subpackage name: "))
    (setq packname (read-string "֥ѥå̾ϤƤ=> "))
    (insert "\n%package " packname"\n")
    (rpm-interactive-summary)
    (rpm-interactive-group)
    (insert "%description " packname"\n\n\n")
    ;(message "Do you want to build more subpackages ? Y)es N)o :")
    (message "¾Υ֥ѥåޤ Y)es N)o : ")
    (if (string-match "y" (char-to-string (read-char)))
    	(setq subpackages "y") (setq subpackages "n"))
    )
  )

; %setupޥ
(defun rpm-interactive-setupmacro ()
  "Insert the %setup interactively"
  (interactive)
  (while (>= nums 0)
    (message " %%setup ޥ˥ץɬפǤ Y)es N)o :")
    (let ((ans (char-to-string (read-char))))
      (cond
       ((string-match "y" ans)
	(rpm-setupmacro ans))
       ((string-match "n" ans)
	(insert "%setup\n"))
       (t (insert "%setup\n"))))
    (setq nums (- nums 1))
    )
  )

; %setupޥΥ֥롼
(defun rpm-setupmacro (setupmacroans)
  "Subroutine for rpm-interactive-setupmacro"
  (interactive)
  (setq setupmacron nil)
  (setq setupmacroc nil)
  (setq setupmacroD nil)
  (setq setupmacroT nil)
  (setq setupmacrob nil)
  (setq setupmacroa nil) 
  (while (string-match "y" setupmacroans)
    (message "0)-n<name>  1)-c  2)-D  3)-T  4)-b<n>  5)-a<n>")
    (let ((ans (char-to-string (read-char))))
      (cond
       ((string-match "0" ans) ;-n
	;(setq setupmacron (read-string "Please insert a directory name for -n: "))
	(setq setupmacron (read-string "-n ΤΥǥ쥯ȥ̾ϤƤ=> "))
	(setq setupmacron (concat "-n " setupmacron)))
       ((string-match "1" ans) ;-c
	(setq setupmacroc "-c"))
       ((string-match "2" ans) ;-D
	(setq setupmacroD "-D"))
       ((string-match "3" ans) ;-T
	(setq setupmacroT "-T"))
       ((string-match "4" ans) ;-b
	;(setq setupmacrob (read-string "Please insert a source number for -b: "))
	(setq setupmacrob (read-string "-b ΤΥեֹϤƤ=> "))
	(setq setupmacrob (concat "-b "  setupmacrob)))
       ((string-match "5" ans) ;-a
	;(setq setupmacroa (read-string "Please insert a source number for -a: "))
	(setq setupmacroa (read-string "-a ΤΥեֹϤƤ=> "))
	(setq setupmacroa (concat "-a "  setupmacroa)))
       (t (message "skipped setup macro!"))
       ))
    (message "¾ΥץĤޤ Y)es N)o :")
    (let ((ans (char-to-string (read-char))))
      (cond
       ((string-match "y" ans)
	(setq setupmacroans "y"))
       ((string-match "n" ans)
	(setq setupmacroans "n"))
       (t (setq setupmacroans "n"))
       )))
  (setq setupmacrooptions (concat setupmacron " " setupmacroc " " setupmacroD 
				  " " setupmacroT " " setupmacrob 
				  " " setupmacroa "\n"))
  (insert "%setup " setupmacrooptions)
  )

; %patch ޥ
(defun rpm-interactive-patchmacro ()
  "Insert the %patch interactively"
  (interactive)
  (if (>= nump 0)
      (progn (while (>= nump 0)
	       (message " %%patch ޥ˥ץɬפǤ? Y)es N)o :")
	       (let ((ans (char-to-string (read-char))))
		 (cond
		  ((string-match "y" ans)
		   (rpm-patchmacro ans))
		  ((string-match "n" ans)
		   (insert "%patch \n"))
		  (t (message "skipped!"))))
	       (setq nump (- nump 1))
	       ))
    )
  )

; %patch ޥΥ֥롼
(defun rpm-patchmacro (patchmacroans)
  "Subroutine for rpm-interactive-patchmacro"
  (interactive)
  (setq patchmacroP nil)
  (setq patchmacrop nil)
  (setq patchmacrob nil)
  (setq patchmacroE nil)
  (setq patchmacroans "y")
  (while (string-match "y" patchmacroans)
    (message "0)-P<n>  1)-p<n>  2)-b<name>  3)-E")
    (let ((ans (char-to-string (read-char))))
      (cond
       ((string-match "0" ans);-P
	;(setq patchmacroP (read-string "Please insert patch number: "))
	(setq patchmacroP (read-string "patch եֹ(Patch<n>:  n)=> "))
	(setq patchmacroP (concat "-P " patchmacroP)))
       ((string-match "1" ans);-p
	;(setq patchmacrop (read-string "Please insert the pathname strip count: "))
	(setq patchmacrop (read-string "ѥ(patch ޥɤ -p ץ)=> "))
	(setq patchmacrop (concat "-p " patchmacrop)))
       ((string-match "2" ans);-b
	;(setq patchmacrob (read-string "Please insert name as patch suffix: "))
	(setq patchmacrob (read-string "ѥåƤΥեˤĤĥ=> "))
	(setq patchmacrob (concat "-b " patchmacrob)))
       ((string-match "3" ans)
	(setq patchmacroE "-E "))
       ))
    (message "¾ΥץĤޤ Y)es N)o :")
    (let ((ans (char-to-string (read-char))))
      (cond
       ((string-match "y" ans)
	(setq patchmacroans "y"))
       ((string-match "n" ans)
	(setq patchmacroans "n"))
       (t (setq patchmacroans "n"))
       )))
  (setq patchmacrooptions (concat patchmacroP " " patchmacrop " " patchmacrob
				  " " patchmacroE "\n"))
  (insert "%patch " patchmacrooptions)
  )

;%build 
(defun rpm-interactive-build ()
  "Insert the %build interactively"
  (interactive)
  (insert "\n\n%build\n")
  ;(message "This source has Imakefile or configure ? I)makefile C)onfigure N)one :")
  (message "Imakefile  configure ץȤϤޤ I)makefile C)onfigure N)one :")
  (setq makemode
	(let ((ans (char-to-string (read-char))))
	  (cond
	   ((string-match "i" ans)
	    (insert "xmkmf -a\n")
	    (insert "make\n")
	    "Imakefile")
	   ((string-match "c" ans)
	    (insert "%configure\n")
	    (insert "make\n")
	    "Configure")
	   ("None"))))
  (insert "\n\n\n")
  )

;$RPM_BUILD_ROOT ƤȤ X11 طΥץȤ
(defun rpm-interactive-if_defined_buildroot ()
  "buildroot ƤȤ%prep rm -rf ڤ X11 ط
ǥ쥯ȥκ."
  (interactive)
  (if (boundp 'buildroot)
    (progn
      (insert "\nrm -rf $RPM_BUILD_ROOT\n")
      ;(message "Do you want to create the X11R6 directory ? Y)es N)o :")
      (message "X11R6 ѤΥǥ쥯ȥޤ Y)es N)o :")
      (let ((ans (char-to-string (read-char))))
	(cond
	 ((string-match "y" ans)
	  (rpm-buildroot-x11))
	 ((string-match "n" ans)
	  (insert "mkdir -p $RPM_BUILD_ROOT\n"))
	 (t (insert "mkdir -p $RPM_BUILD_ROOT\n"))
	 )))

    )
  )
;δؿΥ֥롼(ץ)
(defun rpm-buildroot-x11 ()
  "Subroutine for rpm-interactive-if_defined_buildroot"
  (interactive)
  (insert "mkdir -p $RPM_BUILD_ROOT/usr/X11R6\n")
  (insert "if [ -d /usr/X11R6.1 ];then")
  (insert "  ln -sf $RPM_BUILD_ROOT/usr/X11R6 $RPM_BUILD_ROOT/usr/X11R6.1\n")
  (insert "fi\n")
  (insert "if [ -d /usr/X11R6.3 ];then\n")
  (insert "  ln -sf $RPM_BUILD_ROOT/usr/X11R6 $RPM_BUILD_ROOT/usr/X11R6.3\n")
  (insert "fi\n")
  (insert "mkdir -p $RPM_BUILD_ROOT/usr/X11R6/bin\n")
  (insert "mkdir -p $RPM_BUILD_ROOT/usr/X11R6/man/man1\n\n\n")
  )
;%install 
(defun rpm-interactive-install ()
  "Insert %install"
  (interactive)
  (insert "%install\n")
  (cond
   ((string-match "Imakefile" makemode)
    (insert "make DESTDIR=$RPM_BUILD_ROOT install\n")
    (insert "make DESTDIR=$RPM_BUILD_ROOT install.man\n"))
   ((string-match "Configure" makemode)
    (insert "make DESTDIR=$RPM_BUILD_ROOT install\n")))
  (insert "\n\n\n")
  )
;%clean (RPM_BUILD_ROOT ƤȤޤ)
(defun rpm-interactive-clean ()
  "Insert %clean tag"
  (interactive)
  (insert "%clean\n")
  (if (boundp 'buildroot)
      (insert "rm -rf $RPM_BUILD_ROOT\n\n\n")
    (insert "\n\n\n")
    )
  )

;󥹥ȡΥ(%pre %post %preun %postun %triggerʤ)
(defun rpm-interactive-install_time_script ()
  "Insert %pre %post %preun %postun %trigger "
  (interactive)
  (message "%%pre ޤ Y)es: N)o:")
  (if (string-match "y" (char-to-string (read-char)))
      (insert "%pre\n\n"))
  (message "%%post ޤ Y)es: N)o:")
  (if (string-match "y" (char-to-string (read-char)))
      (progn (insert "%post\n\n")
	     (rpm-interactive-install-info)))
  (message "%%preun ޤ Y)es: N)o:")
  (if (string-match "y" (char-to-string (read-char)))
      (insert "%preun\n\n"))
  (message "%%trigger ޤ Y)es: N)o:")
  (if (string-match "y" (char-to-string (read-char)))
      (insert "%trigger\n\n"))
  )


;%files
(defun rpm-interactive-files ()
  (interactive)
  (insert "%files\n")
  )

;
;install info file
(defun rpm-interactive-install-info ()
  "Insert INFO file"
  (interactive)
  (setq infoans "y")
  (message "Info ե򥤥󥹥ȡ뤷ޤ Y)es: N)o:")
  (if (string-match "y" (char-to-string (read-char)))
      (while (string-match "y" infoans)
	(setq infofile (read-string "Info ե̾ϤƤ=> "))
	(setq infoentry (read-string "Info ȥ̾ϤƤ=> "))
	(setq infosection (read-string "Info ̾ϤƤ=> "))
	(insert "/sbin/install-info /usr/info/" infofile " /usr/info/dir --entry=\"" infoentry
		"\" " "--section=\"" infosection "\" \n" )
	(message "¾ˤ Info եϤޤ Y)es: N)o:")
	(if (string-match "y" (char-to-string (read-char)))
	    (setq infoans "y")
	  (progn (setq infoans "n")
		 (message "%%preun ˺ʸ񤯤Τ˺ʤǤ"))
	  )
	)
    )
  (insert "\n")
  )

;==============================================================
;==============================================================
;----- rpm θƤӽФط -----------------------------------
;; rpm Υץƻ
(defvar rpm-process nil)


;; C-c r
(defun rpm-exec ()
  "Exec rpm "
  (interactive)
  (message "rpm Build option :0)-bp 1)-bl 2)-bc 3)-bi 4)-bb 5)-ba")
  (let ((ans (char-to-string (read-char))))
    (cond
     ((string-match "0" ans)
      (setq bopt "-bp"))
     ((string-match "1" ans)
      (setq bopt "-bl"))
     ((string-match "2" ans)
      (setq bopt "-bc"))
     ((string-match "3" ans)
      (setq bopt "-bi"))
     ((string-match "4" ans)
      (setq bopt "-bb"))
     ((string-match "5" ans)
      (setq bopt "-ba"))
     (t ())
     )
    )
  (if (y-or-n-p "¾Υץդޤ?")
      (progn
	;(setq otheropt(read-string "Please insert other options: "))
	(setq otheropt(read-string "¾Υץ=> "))
	(rpm-rpm bopt otheropt)
	(message (format "Exectuting rpm %s %s ..." bopt otheropt)))
    (progn
      (rpm-rpm bopt)
      (message (format "Exectuting rpm %s ..." bopt))
      )
    )
  )



;;rpm-rpm (eldic.el ήѡ¤)
(defun rpm-rpm (bopt &optional otheropt)
  "rpm ޥɼ¹"
  (if rpm-process
      (if (or (not (eq (process-status rpm-process) 'run)) 
	      ;(yes-or-no-p "rpm process is running,  kill it ? "))
	      (yes-or-no-p "¾ rpm ץ¸ߤޤkill ޤ Y)es N)o :"))
	  (condition-case ()
	      (let ((comp-proc rpm-process))
		(interrupt-process comp-proc)
		(sit-for 1)
		(delete-process comp-proc))
	    (error nil))
	(error "Can not have two rpm processes")))
  (setq rpm-process nil)
  (setq spec-name (buffer-name))
;  (setq LANG (setenv "LANG" "C"))
  (if (eq nil otheropt)
      (progn 
	(setq rpm-process (start-process "compilation"  "*RPM RESULT*"
				   "rpm" bopt  spec-name)))
    (progn 
      (setq rpm-process (start-process "compilation"  "*RPM RESULT*"
				   "rpm" bopt otheropt  spec-name)))
    )
  (with-output-to-temp-buffer "*RPM RESULT*")
  (let (save-excursion (set-buffer "*RPM RESULT*")))
  (set-process-sentinel rpm-process 'rpm-sentinel)
  )
;; process ƻ
(defun rpm-sentinel (proc msg)
  "ץƻ"
  (cond ((null (buffer-name (process-buffer proc)))
         ;; buffer killed
	 (set-process-buffer proc nil))
        ((memq (process-status proc) '(signal exit))
         (let* ((obuf (current-buffer))
                omax opoint)
           ;; save-excursion isn't the right thing if
	   ;;  process-buffer is current-buffer
	   (unwind-protect
	       (progn
		 ;; Write something in *compilation* and hack its mode line,
		 (set-buffer (process-buffer proc))
		 (setq omax (point-max) opoint (point))
		 (goto-char (point-max))
		 (insert ?\n mode-name " " msg)
		 (forward-char -1)
		 (insert " at "
			 (substring (current-time-string) 0 -5))
		 (forward-char 1)
		 (setq mode-line-process
		       (concat ": "
			       (symbol-name (process-status proc))))
		 ;; If buffer and mode line will show that the process
		 ;; is dead, we can delete it now.  Otherwise it
		 ;; will stay around until M-x list-processes.
		 (delete-process proc))
	     (setq rpm-process nil)
	     ;; Force mode line redisplay soon
	     (set-buffer-modified-p (buffer-modified-p)))
	   (if (and opoint (< opoint omax))
	       (goto-char opoint))
	   (set-buffer obuf)))))

;;C-c d
;;------------------- dump $BuildRoot -------------------
;;C-c b rpm-mode.el ѿ buildroot (=$RPM_BUILD_ROOT)
;;ƤȤbuildroot Υǥ쥯ȥ깽פ롥
;;($RPM_BUILD_ROOT ˥󥹥ȡ(C-c r  rpm -bi
;; ʤɤ)Ƥ뤳Ȥ)
(defun rpm-interactive-if_defined_buildroot_dumpdir ()
  "buildroot ƤȤ$buildrootפ"
  (interactive)
  (if (boundp 'buildroot)
      (if (not (equal nil buildroot))
	  (progn
;	    (setq com 
;		  (concat "\"cd" " " buildroot ";" 
;			  "tar" " "  "cvf"  " "  "/dev/null"  " ./" 
;			  "|sed" " " "-e '/^\\./d'"
;			  "|sed" " " "-e '/^/s//\\//'\""))
	    (setq com
		  (concat "\"find" " " buildroot " -print " "|"
			  "sed \"s^" buildroot "^^\"\""))
	    (setq currentbuf (current-buffer))
	    (if (y-or-n-p 
		 (message (format "BuildRoot: [%s]" buildroot)))
		(start-process-shell-command "dump-build-dir" currentbuf 
					     shell-file-name 
					     "-c" com)
	      (progn
		;(setq buildroot (read-string "Please insert BuildRoot: "))
		(setq buildroot (read-string "BuildRoot ϤƤ=> "))
		(rpm-interactive-if_defined_buildroot_dumpdir))))
	      (error "Defined Buildroot is void. Quit!"))
    (progn
      (defvar buildroot 
	;(read-string "BuildRoot not defined ! Please insert BuildRoot: "))
	(read-string "BuildRoot Ƥޤ BuildRoot ϤƲ=> "))
      (rpm-interactive-if_defined_buildroot_dumpdir))
    )
  )

;;------------------- hilit ------------------------------
;;οդ(ʤꤤø)
(if (and 
     (not (featurep 'xemacs))
     (string= (substring emacs-version 0 5) "19.28")
     (eq window-system 'x))
    (cond (window-system
       (hilit-set-mode-patterns 
	'rpm-mode
	'(("#.*" nil comment)
      ("^[Nn]ame:" nil defun)
      ("^[Vv]ersion:" nil defun)
      ("^[Rr]elease:" nil defun)
      ("^[Ss]erial:" nil defun)
      ("^[Ss]ummary:" nil defun)
      ("^[Ss]ummary([a-zA-Z._]+):" nil defun)
      ("^[Cc]opyright:" nil defun)
      ("^[Dd]istribution:" nil defun)
      ("^[Ii]con:" nil  defun)
      ("^[Vv]endor:" nil defun)
      ("^[Uu][Rr][Ll]:" nil defun)
      ("^[Gg]roup:" nil defun)
      ("^[Pp]ackager:" nil defun)
      ("^[Nn]o[Ss]ource[0-9]*:" nil defun)
      ("^%[Nn]o[Ss]ource[ \t]+[0-9]*" nil defun)
      ("^[Nn]o[Pp]atch[0-9]*:" nil defun)
      ("^%[Nn]o[Pp]atch[ \t]+[0-9]*" nil defun)
      ("^[Ss]ource[0-9]*:" nil defun)
      ("^[Pp]atch[0-9]*:" nil defun)
      ("^[Ee]xclude[Aa]rch:" nil defun)
      ("^[Ee]xclusive[Aa]rch:" nil defun)
      ("^[Ee]xclude[Oo][Ss]:" nil defun)
      ("^[Ee]xclusive[Oo][Ss]:" nil defun)
      ("^[Pp]refixes:" nil defun)
      ("^[Pp]refix:" nil defun)
      ("^[Bb]uild[Rr]oot:" nil defun)
      ("^[Bb]uild[Cc]onflicts:" nil defun)
      ("^[Bb]uild[Pp]re[Rr]eq:" nil defun)
      ("^[Bb]uild[Rr]equires:" nil defun)
      ("^[Bb]uild[Aa]rch:" nil defun)
      ("^[Bb]uild[Aa]rchitectures:" nil defun)
      ("^[Ll]icense:" nil defun)
      ("^[Pp]rovides:" nil defun)
      ("^[Rr]equires:" nil defun)
      ("^[Pp]re[Rr]eq:" nil defun)
      ("^[Cc]onflicts:" nil defun)
      ("^[Oo]bsoletes:" nil defun)
      ("^[Aa]uto[Rr]eq[Pp]rov:" nil defun)
      ("^[Aa]uto[Rr]eq:" nil defun)
      ("^[Aa]uto[Pp]rov:" nil defun)
      ("^[Dd]oc[Dd]ir:" nil defun)
      ("^\*.*$" nil defun)
      ("^%description" nil define)
      ("^%changelog" nil define)
      ("^%package" nil define)
      ("^%prep" nil define)
      ("^%setup" nil define)
      ("^%patch[0-9]+" nil define)
      ("^%build" nil define)
	  ("%configure" nil define)
      ("^%clean" nil define)
      ("^%build" nil define)
      ("^%clean" nil define)
	  ("%install" nil define)
      ("%make" nil define)
      ("%makeinstall" nil define)
      ("^%pre" nil define)
      ("^%post" nil define)
      ("^%preun" nil define)
      ("^%postun" nil define)
      ("^%verifyscript" nil define)
      ("^%triggerin" nil define)
      ("^%triggerun" nil define)
      ("^%triggerpostun " nil define)
      ("^%files" nil define)
      ("^%config" nil define)
      ("^%config(missingok)" nil define)
      ("^%config(noreplace)" nil define)
      ("^%ghost" nil define)
	  ("%docdir" nil define)
      ("%doc" nil define)
	  ("%dir" nil define)
      ("^%attr(.*,.*,.*)" nil define)
      ("^%defattr(.*,.*,.*)" nil define)
      ("^%verify(.*)" nil define)
      ("^%defverify(.*)" nil define)
      ("^%verifyscript" nil define)
      ("^%lang" nil define)
      ("^%lang([a-zA-Z._]+)" nil define)
      ("%{\\??[^}]+}" nil define)
	  ("%[^ \t\n]+" nil define)
      ("^%ifn?arch" nil define)
      ("^%ifn?os" nil define)
      ("^%if" nil define)
      ("^%else" nil define)
      ("^%endif" nil define)
      ("^%define" nil define)
      ("^%global" nil define)
	  ("$RPM_SOURCE_DIR" nil include)
	  ("$RPM_BUILD_DIR" nil include)
	  ("$RPM_DOC_DIR" nil include)
	  ("$RPM_ROOT_DIR" nil include)
	  ("$RPM_BUILD_ROOT" nil include)
	  ("$RPM_INSTALL_PREFIX" nil include)
	  ("$RPM_OPT_FLAGS" nil include)
	  ("$RPM_ARCH" nil include)
	  ("$RPM_OS" nil include)
	  ("$RPM_PACKAGE_NAME" nil include)
	  ("$RPM_PACKAGE_VERSION" nil include)
	  ("$RPM_PACKAGE_RELEASE" nil include)
	  ("${[a-zA-Z_][a-zA-Z0-9_]*}" nil include)
	  ))
       ))
  )

;;------------ face (for xemacs, emacs19.34, emacs20) -----------
;;οդ(hilitΤȤƱŬ (^^; )
(if (or (and (featurep 'font-lock)
	     (not (string= (substring emacs-version 0 5) "19.28")))
	(featurep 'xemacs))
    (progn
      (defconst rpm-font-lock-keywords 
	(list
	 '("^#.*$" . font-lock-comment-face)
	 (cons
	  (mapconcat
	   'identity
       '("^[Ss]ummary:"
         "^[Ss]ummary([a-zA-Z._]+):"
         "^[Vv]ersion:"
         "^[Rr]elease:"
         "^[Nn]ame:"
         "^[Ss]erial:"
         "^[Cc]opyright:"
         "^[Dd]istribution:"
         "^[Vv]endor:"
         "^[Gg]roup:"
         "^[Pp]ackager:"
         "^[Uu][Rr][Ll]:"
         "^\\([Nn]o\\|\\)[Ss]ource[0-9]*:"
         "^%?\\([Nn]o\\|\\)[Ss]ource[ \t]+[0-9]*"
         "^\\([Nn]o\\|\\)[Pp]atch[0-9]*:"
         "^%?\\([Nn]o\\|\\)[Pp]atch[ \t]+[0-9]*"
         "^[Ee]xclude[Aa]rch:"
         "^[Ee]xclusive[Aa]rch:"
         "^[Ee]xclude[Oo][Ss]:"
         "^[Ee]xclusive[Oo][Ss]:"
         "^[Ii]con:"
         "^[Ll]icense:"
         "^[Pp]rovides:"
         "^[Rr]equires:"
         "^[Pp]re[Rr]eq:"
         "^[Cc]onflicts:"
         "^[Oo]bsoletes:"
         "^[Pp]refix:"
         "^[Pp]refixes:"
         "^[Bb]uild[Rr]oot:"
         "^[Bb]uild[Cc]onflicts:"
         "^[Bb]uild[Rr]equires:"
         "^[Bb]uild[Pp]re[Rr]eq:"
         "^[Bb]uild[Aa]rchitectures:"
         "^[Bb]uild[Aa]rch:"
         "^[Aa]uto[Rr]eq[Pp]rov:"
         "^[Aa]uto[Rr]eq:"
         "^[Aa]uto[Pp]rov:"
         "^[Dd]ocdir:"
	     )
	   "\\|")
	  'font-lock-keyword-face)
	 (cons
	  (mapconcat
	   'identity
       '("%{[^\\?][^}]+}")
       "\\|")
      'font-lock-reference-face)
     (cons
      (mapconcat
       'identity
       '("%configure"
         "^%define"
         "%make\\(install\\|\\)"
         "^%attr(.*,.*,.*)"
         "^%defattr(.*,.*,.*)"
         "^%defverify(.*)"
         "^%else"
         "^%endif"
         "^%ghost"
         "^%global"
         "^%ifn?\\(arch\\|os\\|\\)"
         "^%patch[0-9]*"
         "^%setup"
         "^%trigger\\(in\\|un\\|postun\\)"
         "^%verify(.*)"
         "^%verifyscript"
         "%{\\?[^}]+}$"
         "%[^ \t\n]+"
	     )
	   "\\|")
	  (if (featurep 'xemacs)
	      'font-lock-string-face
	    'font-lock-function-name-face))
	 (cons
	  (mapconcat
	   'identity
       '("%dir"
         "%docdir"
         "%doc"
         "%config\\(\(missingok\)\\|\(noreplace\)\\|\\)"
         )
       "\\|")
      'font-lock-type-face)
     (cons
      (mapconcat
       'identity
       '("^%description"
         "^%changelog"
         "^%files"
         "^%install"
         "^%package"
         "^%lang\\(\([a-zA-Z._]+\)\\|\\)"
         "^%post\\(un\\|\\)"
         "^%pre\\(un\\|p\\|\\)"
         "^%build"
         "^%clean"
         )
       "\\|")
      'font-lock-builtin-face)
     (cons
      (mapconcat
       'identity
	   '("$RPM_SOURCE_DIR"
	     "$RPM_BUILD_DIR"
	     "$RPM_DOC_DIR"
	     "$RPM_ROOT_DIR"
	     "$RPM_BUILD_ROOT"
	     "$RPM_INSTALL_PREFIX"
	     "$RPM_OPT_FLAGS"
	     "$RPM_ARCH"
	     "$RPM_OS"
	     "$RPM_PACKAGE_NAME"
	     "$RPM_PACKAGE_VERSION"
	     "$RPM_PACKAGE_RELEASE"
	     "${[a-zA-Z_][a-zA-Z0-9_]*}"
	     )
	   "\\|")
	  'font-lock-variable-name-face)
     (cons
      (mapconcat
       'identity
       '("^\*.+$")
       "\\|")
      'font-lock-warning-face)
	 ))
      (if (featurep 'xemacs)
	  (put 'rpm-mode 'font-lock
	       '(rpm-font-lock-keywords nil))
	(add-hook
	 'rpm-mode-hook
	 (lambda ()
	   (make-local-variable 'font-lock-defaults)
	   (setq font-lock-defaults
		 '((rpm-font-lock-keywords) nil nil
		   ((?/ . "w") (?~ . "w") (?. . "w") (?- . "w") (?_ . "w"))))))
	)
      ))
      
;;------------------- Setup -----------------------------------
(setq auto-mode-alist (append '(("\\.spec$" . rpm-mode))
                              auto-mode-alist))
